﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
'things to note
'the field names are case sensitive
Sub Class_Globals
	Public BANano As BANano
	Public alaSQL As BANanoSQL
	Private ToExecute As Int = 0 
	Private Executed As Int = 0
	Private vDBName As String
End Sub

'open the database
Public Sub Initialize(dbName As String)
	vDBName = dbName
	alaSQL.Open("SQL", dbName)
End Sub

'to insert a record, first lets see if its existing
Sub CheckFlight(fn As Int)
	Dim flights As Map = CreateMap("flightNo": fn)
	Dim sqlm As Map = modDB.SelectWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.Execute(sql, values, modDB.DB_EXISTS)
End Sub

Sub DeleteFlight(fn As Int)
	'please note the operator =
	Dim flights As Map = CreateMap("flightNo =": fn)
	Dim sqlm As Map = modDB.DeleteWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.Execute(sql, values, modDB.DB_DELETE)
End Sub

Sub CreateFlightsTable
	'lets create a table to store data
	'flights (flightNo INT, fromCity STRING, toCity STRING, isInTheAir BOOL)
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", modDB.DB_INT)
	flights.Put("fromCity", modDB.DB_STRING)
	flights.Put("toCity", modDB.DB_STRING)
	flights.Put("isInTheAir", modDB.DB_BOOL)
	Dim sql As String = modDB.CreateTableSQL("flights",flights,"flightNo")
	alaSQL.Execute(sql, Null, modDB.DB_CREATE)
End Sub

'should be specific to project
Sub InsertFlight(fn As Int)
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", fn)
	flights.Put("fromCity", "Brussels")
	flights.Put("toCity", "Paris")
	flights.Put("isInTheAir", True)
	Dim sqlm As Map = modDB.InsertSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.Execute(sql, values, modDB.DB_INSERT)
End Sub

'should be specific to project
Sub UpdateFlight(fn As Int)
	'fields to update
	Dim flights As Map
	flights.Initialize
	flights.Put("fromCity", "Paris")
	flights.Put("toCity", "Brussels")
	flights.Put("isInTheAir", False)
	'select this one
	Dim wherem As Map
	wherem.Initialize 
	wherem.Put("flightNo", fn)
	Dim sqlm As Map = modDB.UpdateWhereSQLMap("flights", flights, wherem)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.Execute(sql, values, modDB.DB_UPDATE)
End Sub

'update all flights
Sub UpdateAllFlights
	'fields to update
	Dim flights As Map
	flights.Initialize
	flights.Put("fromCity", "East London")
	flights.Put("toCity", "Israel")
	flights.Put("isInTheAir", True)
	Dim sqlm As Map = modDB.UpdateSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.Execute(sql, values, modDB.DB_UPDATEALL)
End Sub

'find a record flights
Sub SelectAFlight
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", 1)
	flights.Put("fromCity", "East London")
	Dim sqlm As Map = modDB.SelectWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.Execute(sql, values, modDB.DB_SELECT)
End Sub


Sub SQL_SQLOpened()
	Log("Database: " & vDBName & " opened successfully!")
	'lets create the flights table
	CreateFlightsTable		
End Sub

Sub SQL_SQLExecuteError(Tag As String, Reason As String)
	Log("ERROR for TAG:" & Tag & " Reason:" & Reason)
End Sub

Sub SQL_SQLExecuteResult(Tag As String, Result As List)
	Select Case Tag
		Case modDB.DB_XLS
			Log(Result)
		Case modDB.DB_ATTACH
			Log(Result.Size)
			Log(Result.Get(0))
			'For Each rec As Object In Result
			'	Log(rec)
			'Next
		Case modDB.DB_CREATEINDEX
			'lets add indexes to the table
			Executed = Executed + 1
		Case modDB.DB_CREATE
			'CreateFlightsIndexes
			'check the record existance first before you add it
			'XLS("flights")
			CheckFlight(1)
		Case modDB.DB_EXISTS
			Select Case Result.Size
			Case 0
				'record does not exist, add it
				InsertFlight(1)
			Case Else
				'record exists, update it
				UpdateFlight(1)
			End Select
		Case modDB.DB_INSERT
			UpdateFlight(1)
		Case modDB.DB_UPDATE
			UpdateAllFlights
		Case modDB.DB_UPDATEALL
			Dim sql As String = modDB.CreateHTMLTable("res","flights")
			alaSQL.Execute(sql,Null, modDB.DB_HTML)
			SelectAFlight
		Case modDB.DB_HTML
			Log(Result)
			
		Case modDB.DB_SELECT
			Log(Result.Size)
			For Each recordm As Map In Result
				Log(recordm)
			Next
			'DeleteFlight(1)
		Case modDB.DB_DELETE
			Dim sql As String = modDB.DropTable("flights")
			alaSQL.Execute(sql, Null, modDB.DB_DROPTABLE)  
		Case modDB.DB_DROPTABLE
			Log("TABLE DROPPED")
			Dim sql As String = modDB.DropDatabase(vDBName)
			alaSQL.Execute(sql,Null, modDB.DB_DROPDATABASE)
		Case modDB.DB_DROPDATABASE
			Log("DATABASE DROPPED")
	End Select
End Sub

